/********************************************************************
	created:	2010/04/10   18:50
	modified:	2010/04/15   09:40 
	author:		Dmitry.Andriyankov
  e-mail:   ntvisigoth@gmail.com
	
	purpose:	Marked bytys in the Hiew to C-source and put it in the
            clipboard.
  IDE:      MS Visual Studio 2008 Team Suite
*********************************************************************/


#include ".\hemsdk\hem.h"
#include <Windows.h>
#include <cstdlib>
#include <string>

/*----------------------------------------------------------------------------*/
#define   PLUG_MAJOR_VER    1
#define   PLUG_MINOR_VER    0

/*----------------------------------------------------------------------------*/
int HEM_API   Hem_Unload( void ),
              Hem_EntryPoint( HEMCALL_TAG *hemCall );

/*----------------------------------------------------------------------------*/
static HEMINFO_TAG plg_heminfo =
{
  sizeof(HEMINFO_TAG),
  sizeof(int),
  0,
  HEM_SDK_VERSION_MAJOR,
  HEM_SDK_VERSION_MINOR,
  PLUG_MAJOR_VER,
  PLUG_MINOR_VER,
  HEM_FLAG_CODE|HEM_FLAG_HEX|HEM_FLAG_MARKEDBLOCK|HEM_FLAG_FILEMASK,
  0,
  Hem_EntryPoint,
  Hem_Unload,
  NULL,
  0,0,0,0,
  "mbytes2csrc",
  "Marked bytes to C-Source",
  ""  
};

const int  menu_width =6;
const int  menu_cnt   =3;
char * menu_lines[menu_cnt] = { "Byte", "Word", "Dword" };

const std::string def( "#define MB_BUF_SIZE 0x" );
const std::string mbbeg_db("\r\nunsigned char  marked_bytes[MB_BUF_SIZE] = {\r\n");
const std::string mbbeg_dw("\r\nunsigned short  marked_words[MB_BUF_SIZE] = {\r\n");
const std::string mbbeg_dd("\r\nunsigned int  marked_dwords[MB_BUF_SIZE] = {\r\n");
const std::string mbend("\r\n};\r\n");

/*----------------------------------------------------------------------------*/
int HEM_EXPORT Hem_Load( HIEWINFO_TAG *hiewInfo )
{
  HiewGate_Set(hiewInfo);
  hiewInfo->hemInfo = &plg_heminfo;
  return(HEM_OK);
}

/*----------------------------------------------------------------------------*/
int convert_bytes2C(const HEM_BYTE * src, int src_len, HEM_BYTE * dest, int dest_len)
{
  int db_cnt = src_len;
  int didx   = 0;
  int sidx   = 0;

  memset(dest,0,dest_len);
  memcpy(dest,def.c_str(),def.length());                  didx += def.length();
  _itoa_s(db_cnt,(char*)&dest[didx],dest_len-didx,16);    for(;dest[didx]; didx++);
  memcpy(&dest[didx],mbbeg_db.c_str(),mbbeg_db.length()); didx += mbbeg_db.length();

  *(WORD*)(&dest[didx]) = 0x2020; didx +=2;

  for(int i=0; i < (db_cnt/8); i++)
  {
    for (int j=0; j<8; j++, didx+=6, sidx++)
    {
      HEM_BYTE b0 = src[sidx] >> 4;
      HEM_BYTE b1 = src[sidx] &  0xF;

      dest[didx]   = '0';
      dest[didx+1] = 'x';
      dest[didx+2] = b0 + ((b0 < 0xA) ? 0x30 : 0x37);  /* Highest 4 bits of Byte to ASCII */
      dest[didx+3] = b1 + ((b1 < 0xA) ? 0x30 : 0x37);  /* Lowest 4 bits of Byte to ASCII  */
      dest[didx+4] = ',';
      dest[didx+5] = ' ';
    }/*for(j...*/

    if(db_cnt/8 > 0)
    {
      *(DWORD*)(&dest[didx]) = 0x20200A0D;  
      didx +=4;
    }
  }/*for(i...*/

  if(db_cnt%8==0)
    didx -= 6;

  for(int i=0; i<(db_cnt%8); sidx++, didx+=4, i++)
  {
    HEM_BYTE b0 = src[sidx] >> 4;
    HEM_BYTE b1 = src[sidx] &  0xF;

    dest[didx]   = '0';
    dest[didx+1] = 'x';
    dest[didx+2] = b0 + ((b0 < 0xA) ? 0x30 : 0x37);  /* Highest 4 bits of Byte to ASCII */
    dest[didx+3] = b1 + ((b1 < 0xA) ? 0x30 : 0x37);  /* Lowest 4 bits of Byte to ASCII  */

    if(i+1 < (db_cnt%8))
    {
      dest[didx+4] = ',';
      dest[didx+5] = ' ';
      didx+=2;
    }
  }

  memcpy(&dest[didx],mbend.c_str(),mbend.length());  didx += mbend.length();
  return(didx);
}

/*----------------------------------------------------------------------------*/
int Convert_words2c(const HEM_BYTE * src, int src_len, HEM_BYTE * dest, int dest_len)
{
  int dw_cnt = src_len/2;
  int didx   = 0;
  int sidx   = 0;

  if(dw_cnt==0)
    return(0);

  memset(dest,0,dest_len);
  memcpy(dest,def.c_str(),def.length());                  didx += def.length();
  _itoa_s(dw_cnt,(char*)&dest[didx],dest_len-didx,16);    for(;dest[didx]; didx++);
  memcpy(&dest[didx],mbbeg_dw.c_str(),mbbeg_dw.length()); didx += mbbeg_dw.length();

  *(WORD*)(&dest[didx]) = 0x2020; didx +=2;

  for(int i=0; i < (dw_cnt/8); i++)
  {
    for (int j=0; j<8; j++, didx+=8, sidx+=2)
    {
      HEM_BYTE b0_0 = src[sidx]   >> 4;
      HEM_BYTE b0_1 = src[sidx]   &  0xF;
      HEM_BYTE b1_0 = src[sidx+1] >> 4;
      HEM_BYTE b1_1 = src[sidx+1] &  0xF;

      dest[didx]   = '0';
      dest[didx+1] = 'x';
      dest[didx+2] = b1_0 + ((b1_0 < 0xA) ? 0x30 : 0x37);  /* Highest 4 bits of Byte to ASCII */
      dest[didx+3] = b1_1 + ((b1_1 < 0xA) ? 0x30 : 0x37);  /* Lowest 4 bits of Byte to ASCII  */
      dest[didx+4] = b0_0 + ((b0_0 < 0xA) ? 0x30 : 0x37);  /* Highest 4 bits of Byte to ASCII */
      dest[didx+5] = b0_1 + ((b0_1 < 0xA) ? 0x30 : 0x37);  /* Lowest 4 bits of Byte to ASCII  */
      dest[didx+6] = ',';
      dest[didx+7] = ' ';
    }/*for(j...*/

    if(dw_cnt/8 > 0)
    {
      *(DWORD*)(&dest[didx]) = 0x20200A0D; 
      didx +=4;
    }
  }/*for(i...*/

  if(dw_cnt%8==0)
    didx -= 6;

  for(int i=0; i<(dw_cnt%8); sidx+=2, didx+=6, i++ )
  {
    HEM_BYTE b0_0 = src[sidx]   >> 4;
    HEM_BYTE b0_1 = src[sidx]   &  0xF;
    HEM_BYTE b1_0 = src[sidx+1] >> 4;
    HEM_BYTE b1_1 = src[sidx+1] &  0xF;

    dest[didx]   = '0';
    dest[didx+1] = 'x';
    dest[didx+2] = b1_0 + ((b1_0 < 0xA) ? 0x30 : 0x37);  /* Highest 4 bits of Byte to ASCII */
    dest[didx+3] = b1_1 + ((b1_1 < 0xA) ? 0x30 : 0x37);  /* Lowest 4 bits of Byte to ASCII  */
    dest[didx+4] = b0_0 + ((b0_0 < 0xA) ? 0x30 : 0x37);  /* Highest 4 bits of Byte to ASCII */
    dest[didx+5] = b0_1 + ((b0_1 < 0xA) ? 0x30 : 0x37);  /* Lowest 4 bits of Byte to ASCII  */

    if(i+1 < (dw_cnt%8))
    {
      dest[didx+6] = ',';
      dest[didx+7] = ' ';
      didx+=2;
    }
  }/*for i...*/

  memcpy(&dest[didx],mbend.c_str(),mbend.length());  didx += mbend.length();
  return(didx);
}

/*----------------------------------------------------------------------------*/
int Convert_dwords2c(const HEM_BYTE * src, int src_len, HEM_BYTE * dest, int dest_len)
{
  int dd_cnt = src_len/4;
  int didx   = 0;
  int sidx   = 0;

  if(dd_cnt==0)
    return(0);

  memset(dest,0,dest_len);
  memcpy(dest,def.c_str(),def.length());                  didx += def.length();
  _itoa_s(dd_cnt,(char*)&dest[didx],dest_len-didx,16);    for(;dest[didx]; didx++);
  memcpy(&dest[didx],mbbeg_dd.c_str(),mbbeg_dd.length()); didx += mbbeg_dd.length();

  *(WORD*)(&dest[didx]) = 0x2020; didx +=2;

  for(int i=0; i < (dd_cnt/4); i++)
  {
    for (int j=0; j<4; j++, didx+=12, sidx+=4)
    {
      HEM_BYTE b0_0 = src[sidx]   >> 4;
      HEM_BYTE b0_1 = src[sidx]   &  0xF;
      HEM_BYTE b1_0 = src[sidx+1] >> 4;
      HEM_BYTE b1_1 = src[sidx+1] &  0xF;
      HEM_BYTE b2_0 = src[sidx+2] >> 4;
      HEM_BYTE b2_1 = src[sidx+2] &  0xF;
      HEM_BYTE b3_0 = src[sidx+3] >> 4;
      HEM_BYTE b3_1 = src[sidx+3] &  0xF;

      dest[didx]    = '0';
      dest[didx+1]  = 'x';
      dest[didx+2]  = b3_0 + ((b3_0 < 0xA) ? 0x30 : 0x37);  /* Highest 4 bits of Byte to ASCII */
      dest[didx+3]  = b3_1 + ((b3_1 < 0xA) ? 0x30 : 0x37);  /* Lowest 4 bits of Byte to ASCII  */
      dest[didx+4]  = b2_0 + ((b2_0 < 0xA) ? 0x30 : 0x37);  /* Highest 4 bits of Byte to ASCII */
      dest[didx+5]  = b2_1 + ((b2_1 < 0xA) ? 0x30 : 0x37);  /* Lowest 4 bits of Byte to ASCII  */
      dest[didx+6]  = b1_0 + ((b1_0 < 0xA) ? 0x30 : 0x37);  /* Highest 4 bits of Byte to ASCII */
      dest[didx+7]  = b1_1 + ((b1_1 < 0xA) ? 0x30 : 0x37);  /* Lowest 4 bits of Byte to ASCII  */
      dest[didx+8]  = b0_0 + ((b0_0 < 0xA) ? 0x30 : 0x37);  /* Highest 4 bits of Byte to ASCII */
      dest[didx+9]  = b0_1 + ((b0_1 < 0xA) ? 0x30 : 0x37);  /* Lowest 4 bits of Byte to ASCII  */
      dest[didx+10] = ',';
      dest[didx+11] = ' ';
    }/*for(j...*/

    if(dd_cnt/4 > 0)
    {
      *(DWORD*)(&dest[didx]) = 0x20200A0D;  
      didx +=4;
    }
  }/*for(i...*/

  if(dd_cnt%4==0)
    didx -= 6;

  for(int i=0; i<(dd_cnt%4); sidx+=4, didx+=10, i++ )
  {
    HEM_BYTE b0_0 = src[sidx]   >> 4;
    HEM_BYTE b0_1 = src[sidx]   &  0xF;
    HEM_BYTE b1_0 = src[sidx+1] >> 4;
    HEM_BYTE b1_1 = src[sidx+1] &  0xF;
    HEM_BYTE b2_0 = src[sidx+2] >> 4;
    HEM_BYTE b2_1 = src[sidx+2] &  0xF;
    HEM_BYTE b3_0 = src[sidx+3] >> 4;
    HEM_BYTE b3_1 = src[sidx+3] &  0xF;

    dest[didx]    = '0';
    dest[didx+1]  = 'x';
    dest[didx+2]  = b3_0 + ((b3_0 < 0xA) ? 0x30 : 0x37);  /* Highest 4 bits of Byte to ASCII */
    dest[didx+3]  = b3_1 + ((b3_1 < 0xA) ? 0x30 : 0x37);  /* Lowest 4 bits of Byte to ASCII  */
    dest[didx+4]  = b2_0 + ((b2_0 < 0xA) ? 0x30 : 0x37);  /* Highest 4 bits of Byte to ASCII */
    dest[didx+5]  = b2_1 + ((b2_1 < 0xA) ? 0x30 : 0x37);  /* Lowest 4 bits of Byte to ASCII  */
    dest[didx+6]  = b1_0 + ((b1_0 < 0xA) ? 0x30 : 0x37);  /* Highest 4 bits of Byte to ASCII */
    dest[didx+7]  = b1_1 + ((b1_1 < 0xA) ? 0x30 : 0x37);  /* Lowest 4 bits of Byte to ASCII  */
    dest[didx+8]  = b0_0 + ((b0_0 < 0xA) ? 0x30 : 0x37);  /* Highest 4 bits of Byte to ASCII */
    dest[didx+9]  = b0_1 + ((b0_1 < 0xA) ? 0x30 : 0x37);  /* Lowest 4 bits of Byte to ASCII  */

    if(i+1 < (dd_cnt%4))
    {
      dest[didx+10] = ',';
      dest[didx+11] = ' ';
      didx+=2;
    }
  }/*for i...*/

  memcpy(&dest[didx],mbend.c_str(),mbend.length());  didx += mbend.length();
  return(didx);
}

/*----------------------------------------------------------------------------*/
bool CopyStrToClipboard(const HEM_BYTE * str, int str_len)
{
  bool res = false;
  HGLOBAL  hglCopy;
  char   * clpbrd;

  if(res = (OpenClipboard(0)) ? true : false )
  {
    hglCopy = GlobalAlloc(GMEM_MOVEABLE | GMEM_DDESHARE, str_len+1);
    if(hglCopy == NULL)
      res = false;

    if(res)
    {
      clpbrd = (char *)GlobalLock(hglCopy);
      memcpy_s(clpbrd,str_len+1,str,str_len);
      clpbrd[str_len+1] = 0x0;
      GlobalUnlock(hglCopy);
      EmptyClipboard();
      SetClipboardData(CF_TEXT, hglCopy);
    }

    CloseClipboard();
    res = true;
  }

  return(res);
}


/*----------------------------------------------------------------------------*/
int HEM_API Hem_EntryPoint( HEMCALL_TAG *hemCall )
{
  HIEWGATE_GETDATA  hdata;
  HEM_BYTE  * src  = NULL;
  HEM_BYTE  * dest = NULL;
  int         dest_len = 0;
  HEM_UINT    len      =0;
  int         dw_cnt   =0;
  int         dd_cnt   =0;
  int         line     =0;
  int         res      =HEM_OK;

  if(hemCall->cbSize < sizeof(HEMCALL_TAG))
    return(HEM_ERROR);

  memset(&hdata,0,sizeof(hdata));
  if( HEM_OK != (res = HiewGate_GetData(&hdata)) )
    return(res);

  if( hdata.sizeMark==0 )
    return(HEM_ERROR);

  line = HiewGate_Menu((HEM_BYTE*)"",
                       (HEM_BYTE**)menu_lines,
                        menu_cnt,
                        menu_width,
                        1,
                        NULL,
                        NULL,
                        NULL,
                        NULL
                        );

  if(line == HEM_INPUT_ESC)
    return(HEM_ERROR);

  len = (HEM_UINT)hdata.sizeMark;
  src = HiewGate_GetMemory(len);

  dw_cnt = len>>1;  /* optimization len/2 , because 2^1 is 2 */
  dd_cnt = len>>2;  /* optimization len/4 , because 2^2 is 4 */

  dest_len = def.length() + mbend.length();
  if(line==1)
    len = dest_len +=( len*6  + ((len/8+1   )*4) + mbbeg_db.length() );
  else if(line==2 && dw_cnt)
    len = dest_len +=( len*8  + ((dw_cnt/8+1)*4) + mbbeg_dw.length() );
  else if(line==3 && dd_cnt)
    len = dest_len +=( len*12 + ((dw_cnt/4+1)*4) + mbbeg_dd.length() );
  else
    src = NULL;
 
  dest= HiewGate_GetMemory(len);

  if(src==NULL || dest==NULL)
    res = HEM_ERROR;

  if(res == HEM_OK)
  {
    if(hdata.sizeMark != HiewGate_FileRead(hdata.offsetMark1,(HEM_UINT)hdata.sizeMark,src) )
      res = HEM_ERROR;
  }

  if(res == HEM_OK)
  {
    if(line==1)
      len = convert_bytes2C(src,(int)hdata.sizeMark,dest,dest_len);
    else if(line==2)
      len = Convert_words2c(src,(int)hdata.sizeMark,dest,dest_len);
    else if(line==3)
      len = Convert_dwords2c(src,(int)hdata.sizeMark,dest,dest_len);
    else
      len = 0;

    if(len) {
      if(!CopyStrToClipboard(dest,len) )
        res = HEM_ERROR;
    }
  }

  HiewGate_FreeMemory(src);
  HiewGate_FreeMemory(dest);

  return( res );
}

/*----------------------------------------------------------------------------*/
int HEM_API Hem_Unload()
{
  return( HEM_OK );
}

/*----------------------------------------------------------------------------*/
